Index: code/branches/ai2/src/modules/weapons/projectiles/Rocket.cc
===================================================================
--- code/branches/ai2/src/modules/weapons/projectiles/Rocket.cc	(revision 8732)
+++ code/branches/ai2/src/modules/weapons/projectiles/Rocket.cc	(revision 8733)
@@ -58,5 +58,5 @@
         this->localAngularVelocity_ = 0;
         this->lifetime_ = 100;
-        this->bIsRocket=true;
+        this->bIsRocket_= true;
 
         if (GameMode::isMaster())
@@ -117,5 +117,5 @@
         if(this->isInitialized())
         {
-            this->bIsRocket=false;
+            this->bIsRocket_= false;
             if (GameMode::isMaster())
             {
Index: code/branches/ai2/src/orxonox/controllers/AIController.cc
===================================================================
--- code/branches/ai2/src/orxonox/controllers/AIController.cc	(revision 8732)
+++ code/branches/ai2/src/orxonox/controllers/AIController.cc	(revision 8733)
@@ -230,6 +230,5 @@
                         this->moveToTargetPosition();
 
-                    if (this->getControllableEntity() && this->bShooting_ && this->isCloseAtTarget(1000) && this->isLookingAtTarget(math::pi / 20.0f))
-                        this->getControllableEntity()->fire(0);
+                    this->doFire();
                 }
 
@@ -267,6 +266,5 @@
                     this->moveToTargetPosition();
 
-                if (this->getControllableEntity() && this->bShooting_ && this->isCloseAtTarget(1000) && this->isLookingAtTarget(math::pi / 20.0f))
-                    this->getControllableEntity()->fire(0);
+                this->doFire();
             }
         }//END_OF DEFAULT MODE
Index: code/branches/ai2/src/orxonox/controllers/ArtificialController.cc
===================================================================
--- code/branches/ai2/src/orxonox/controllers/ArtificialController.cc	(revision 8732)
+++ code/branches/ai2/src/orxonox/controllers/ArtificialController.cc	(revision 8733)
@@ -1049,7 +1049,7 @@
             else if((weapons[3]==3)&& this->isCloseAtTarget(400) /*&&projectiles[3]*/ )
             {//ROCKET: mid range weapon
-                //TODO: Which weapon is the rocket? How many rockets are available?
+                //TODO: How many rockets are available?
                 this->mode_ = ROCKET;//Vector-implementation: mode_.push_back(ROCKET);
-                this->getControllableEntity()->fire(3);//launch rocket
+                this->getControllableEntity()->fire(3);//launch rocket BUG IS TRIGGERED HERE.
                 if(this->getControllableEntity()&&this->target_)//after fire(3) getControllableEntity() refers to the rocket!
                 {
@@ -1081,5 +1081,5 @@
                 for(unsigned int i=0; i<WeaponSystem::MAX_WEAPON_MODES; i++)
                 {
-                    const std::string wpn = getWeaponname(i, pawn); COUT(0)<<wpn<< std::endl;//Temporary debug info.
+                    //const std::string wpn = getWeaponname(i, pawn); COUT(0)<<wpn<< std::endl;//Temporary debug info.
                     /*if(wpn=="")
                         weapons[i]=-1;
Index: code/branches/ai2/src/orxonox/worldentities/ControllableEntity.cc
===================================================================
--- code/branches/ai2/src/orxonox/worldentities/ControllableEntity.cc	(revision 8732)
+++ code/branches/ai2/src/orxonox/worldentities/ControllableEntity.cc	(revision 8733)
@@ -74,4 +74,5 @@
         this->bMouseLook_ = false;
         this->mouseLookSpeed_ = 200;
+        this->bIsRocket_ = false;
 
         this->server_position_         = Vector3::ZERO;
Index: code/branches/ai2/src/orxonox/worldentities/ControllableEntity.h
===================================================================
--- code/branches/ai2/src/orxonox/worldentities/ControllableEntity.h	(revision 8732)
+++ code/branches/ai2/src/orxonox/worldentities/ControllableEntity.h	(revision 8733)
@@ -164,5 +164,5 @@
             void setTargetInternal( uint32_t targetID );
             inline bool getRocket() const
-                { return this-> bIsRocket; }
+                { return this-> bIsRocket_; }
 
         protected:
@@ -183,5 +183,5 @@
 
             Ogre::SceneNode* cameraPositionRootNode_;
-            bool bIsRocket; //Workaround to see, if the controllable entity is a Rocket.
+            bool bIsRocket_; //Workaround to see, if the controllable entity is a Rocket.
 
         private: