Index: code/trunk/src/modules/overlays/hud/HUDRadar.cc
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDRadar.cc	(revision 8737)
+++ code/trunk/src/modules/overlays/hud/HUDRadar.cc	(revision 8738)
@@ -106,4 +106,5 @@
         panel->setMaterialName(TextureGenerator::getMaterialName(
             shapeMaterials_[object->getRadarObjectShape()], object->getRadarObjectColour()));
+        panel->hide();
         this->radarObjects_[object] = panel;
     }
@@ -166,5 +167,5 @@
             float distance = (wePointer->getWorldPosition() - this->owner_->getPosition()).length();
             // calculate the size with 1/distance dependency for simplicity (instead of exp(-distance * lambda)
-            float size = maximumDotSize_ * halfDotSizeDistance_ / (halfDotSizeDistance_ + distance);
+            float size = maximumDotSize_ * halfDotSizeDistance_ / (halfDotSizeDistance_ + distance) * it->first->getRadarObjectScale();
             it->second->setDimensions(size, size);
 
Index: code/trunk/src/modules/weapons/projectiles/Rocket.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Rocket.cc	(revision 8737)
+++ code/trunk/src/modules/weapons/projectiles/Rocket.cc	(revision 8738)
@@ -52,5 +52,8 @@
         Constructor. Registers the object and initializes some default values.
     */
-    Rocket::Rocket(BaseObject* creator) : ControllableEntity(creator), BasicProjectile()
+    Rocket::Rocket(BaseObject* creator)
+        : ControllableEntity(creator)
+        , BasicProjectile()
+        , RadarViewable(creator, static_cast<WorldEntity*>(this))
     {
         RegisterObject(Rocket);// - register the Rocket class to the core
@@ -106,4 +109,8 @@
         camPosition->setAllowMouseLook(true);
         this->addCameraPosition(camPosition);
+
+        this->setRadarObjectColour(ColourValue(1.0, 0.5, 0.0)); // orange
+        this->setRadarObjectShape(RadarViewable::Triangle);
+        this->setRadarObjectScale(0.5f);
     }
 
Index: code/trunk/src/modules/weapons/projectiles/Rocket.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Rocket.h	(revision 8737)
+++ code/trunk/src/modules/weapons/projectiles/Rocket.h	(revision 8738)
@@ -34,4 +34,5 @@
 #include "tools/Timer.h"
 #include "worldentities/ControllableEntity.h"
+#include "interfaces/RadarViewable.h"
 
 #include "BasicProjectile.h"
@@ -48,5 +49,5 @@
         Oli Scheuss
     */
-    class _WeaponsExport Rocket : public ControllableEntity, public BasicProjectile
+    class _WeaponsExport Rocket : public ControllableEntity, public BasicProjectile, public RadarViewable
     {
         public:
Index: code/trunk/src/modules/weapons/projectiles/SimpleRocket.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 8737)
+++ code/trunk/src/modules/weapons/projectiles/SimpleRocket.cc	(revision 8738)
@@ -48,10 +48,13 @@
     CreateFactory(SimpleRocket);
 
-    SimpleRocket::SimpleRocket(BaseObject* creator) : ControllableEntity(creator), BasicProjectile()
+    SimpleRocket::SimpleRocket(BaseObject* creator)
+        : ControllableEntity(creator)
+        , BasicProjectile()
+        , RadarViewable(creator, static_cast<WorldEntity*>(this))
     {
         RegisterObject(SimpleRocket);// - register the SimpleRocket class to the core
 
         this->localAngularVelocity_ = 0;
-        this->lifetime_ = 120;
+        this->lifetime_ = 10;
 
         this->setMass(15);
@@ -86,4 +89,7 @@
         }
 
+        this->setRadarObjectColour(ColourValue(1.0, 1.0, 0.0)); // yellow
+        this->setRadarObjectShape(RadarViewable::Triangle);
+        this->setRadarObjectScale(0.5f);
     }
 
Index: code/trunk/src/modules/weapons/projectiles/SimpleRocket.h
===================================================================
--- code/trunk/src/modules/weapons/projectiles/SimpleRocket.h	(revision 8737)
+++ code/trunk/src/modules/weapons/projectiles/SimpleRocket.h	(revision 8738)
@@ -35,4 +35,5 @@
 #include "worldentities/ControllableEntity.h"
 #include "graphics/ParticleSpawner.h"
+#include "interfaces/RadarViewable.h"
 
 #include "BasicProjectile.h"
@@ -48,5 +49,5 @@
        Gabriel Nadler (Original file: Oli Scheuss)
     */
-    class _WeaponsExport SimpleRocket : public ControllableEntity, public BasicProjectile
+    class _WeaponsExport SimpleRocket : public ControllableEntity, public BasicProjectile, public RadarViewable
     {
         public:
Index: code/trunk/src/orxonox/interfaces/RadarViewable.cc
===================================================================
--- code/trunk/src/orxonox/interfaces/RadarViewable.cc	(revision 8737)
+++ code/trunk/src/orxonox/interfaces/RadarViewable.cc	(revision 8738)
@@ -50,4 +50,5 @@
         , radarObjectShape_(Dot)
         , radarObjectDescription_("staticObject")
+        , scale_(1.0f)
     {
         RegisterRootObject(RadarViewable);
Index: code/trunk/src/orxonox/interfaces/RadarViewable.h
===================================================================
--- code/trunk/src/orxonox/interfaces/RadarViewable.h	(revision 8737)
+++ code/trunk/src/orxonox/interfaces/RadarViewable.h	(revision 8738)
@@ -113,4 +113,16 @@
         inline Shape getRadarObjectShape() const
             { return this->radarObjectShape_; }
+
+        inline void setRadarObjectScale(float scale)
+            {
+                if(this->scale_ != scale)
+                {
+                    this->scale_ = scale;
+                    this->settingsChanged();
+                }
+            }
+        inline float getRadarObjectScale() const
+            { return this->scale_; }
+
         void settingsChanged();
 
@@ -139,5 +151,5 @@
         std::string radarObjectDescription_;
         ColourValue radarObjectColour_;
-
+        float scale_;
     };
 }